using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;
using System.Windows.Input;

namespace Benday.WpfCommandExceptionDemo.ViewModel
{
    /// <summary>
    /// This class contains properties that the main View can data bind to.
    /// <para>
    /// Use the <strong>mvvminpc</strong> snippet to add bindable properties to this ViewModel.
    /// </para>
    /// <para>
    /// You can also use Blend to data bind with the tool's support.
    /// </para>
    /// <para>
    /// See http://www.galasoft.ch/mvvm
    /// </para>
    /// </summary>
    public class MainViewModel : ViewModelBase
    {
        private ICommand _ThrowAnExceptionThatIsHandledCommand;
        public ICommand ThrowAnExceptionThatIsHandledCommand
        {
            get
            {
                if (_ThrowAnExceptionThatIsHandledCommand == null)
                {
                    _ThrowAnExceptionThatIsHandledCommand = 
                        new ExceptionHandlingRelayCommand(DoSomething);
                }

                return _ThrowAnExceptionThatIsHandledCommand;
            }            
        }

        private ICommand _ThrowAnExceptionThatIsNotHandledCommand;
        public ICommand ThrowAnExceptionThatIsNotHandledCommand
        {
            get
            {
                if (_ThrowAnExceptionThatIsNotHandledCommand == null)
                {
                    _ThrowAnExceptionThatIsNotHandledCommand =
                        new RelayCommand(DoSomething);
                }

                return _ThrowAnExceptionThatIsNotHandledCommand;
            }            
        }

        private void DoSomething()
        {
            throw new System.NotImplementedException("Boom!");
        }
    }
}